package org.robotlegs.demos.simplemodule.views
{
	import flash.events.MouseEvent;
	
	import mx.formatters.DateFormatter;
	
	import org.robotlegs.demos.simplemodule.events.ClearAllEvent;
	import org.robotlegs.demos.simplemodule.events.Module1Event;
	import org.robotlegs.demos.simplemodule.events.Module2Event;
	import org.robotlegs.module.simplemodule.SimpleModule;
	import org.robotlegs.mvcs.Mediator;
	
	public class ApplicationMediator extends Mediator
	{
		[Inject]
		
		public function ApplicationMediator()
		{
			super();
		}
		
		public override function onRegister() : void {
			this.eventMap.mapListener(this.eventDispatcher,Module1Event.EVENT_MODULE1, handleEventModule1);
			this.eventMap.mapListener(this.eventDispatcher,Module2Event.EVENT_MODULE2, handleEventModule2);
			this.eventMap.mapListener(
				this.getViewComponent().clearAllBttn,
				MouseEvent.CLICK, handleClearAllClick
			);
		}
		
		protected function handleEventModule1(event:Module1Event):void {
			this.getViewComponent().outputTA.text+=SimpleModule.getFormattedOutput("module1",event.stringTosend);
		}
		
		protected function handleEventModule2(event:Module2Event):void {
			this.getViewComponent().outputTA.text+=SimpleModule.getFormattedOutput("module2",event.stringTosend);
		}
		
		protected function handleClearAllClick(event:MouseEvent):void {
			this.getViewComponent().outputTA.text="";
			this.eventDispatcher.dispatchEvent(new ClearAllEvent());
		}
		
	}
}