package org.robotlegs.demos.simplemodule.views
{
	import mx.formatters.DateFormatter;
	
	import org.robotlegs.demos.simplemodule.events.ClearAllEvent;
	import org.robotlegs.demos.simplemodule.events.Module1Event;
	import org.robotlegs.demos.simplemodule.events.Module2Event;
	import org.robotlegs.module.simplemodule.SimpleModule;
	import org.robotlegs.module.simplemodule.events.SimpleModuleEvent;
	import org.robotlegs.mvcs.Mediator;

	public class ModuleView1Mediator extends Mediator
	{
		[Inject]
		public var simpleModule:SimpleModule;
		
		public function ModuleView1Mediator()
		{
			super();
		}
		
		public override function onRegister():void {
			this.eventMap.mapListener(simpleModule.getRLContext().eventDispatcher, SimpleModuleEvent.EVENT_SIMPLE_MODULE,handleSimpleModuleEvent);
			this.eventMap.mapListener(this.eventDispatcher,Module2Event.EVENT_MODULE2, handleEventModule2);
			this.eventMap.mapListener(this.eventDispatcher,ClearAllEvent.EVENT_CLEAR_ALL, handleClearAllEvent);
			this.simpleModule.view.title="Module1"
		}	
		
		protected function handleSimpleModuleEvent(event:SimpleModuleEvent):void {
			var boolean:Boolean=this.eventDispatcher.dispatchEvent(new Module1Event(Module1Event.EVENT_MODULE1,event.stringTosend));
		}

		protected function handleEventModule2(event:Module2Event):void {
			var formatter:DateFormatter=new DateFormatter();
			formatter.formatString="LL:NN:SS";
			var d:String=formatter.format(new Date());
			this.simpleModule.view.outputTA.text+=getFormattedOutput("Module2",event.stringTosend);
		}
		
		protected function handleClearAllEvent(event:ClearAllEvent):void {
			this.simpleModule.view.outputTA.text="";
		}
		
		private function getFormattedOutput(origin:String,output:String):String {
			var formatter:DateFormatter=new DateFormatter();
			formatter.formatString="LL:NN:SS";
			var d:String=formatter.format(new Date());	
			return d+"("+origin+"):"+output+"\n";
		}
	}
}